library nui_firebase;
import 'dart:developer';

import 'package:firebase_core/firebase_core.dart';
import 'package:nui_core/code/nui_code_util.dart';
import 'package:nui_firebase/nui_firebase_models.dart';

export 'package:nui_firebase/nui_fireauth.dart';
export 'package:nui_firebase/nui_firebase_models.dart';
export 'package:nui_firebase/nui_firestore.dart';

class NUIFirebase{
  List<NUIFireBuilder> _builders = List();

  NUIFirebase withComponent(NUIFireBuilder builder){
    _builders.add(builder);
    return this;
  }

  Future<FireResult<FirebaseApp>> build() async{
    FireResult<FirebaseApp> result;
    try {
      final FirebaseApp fire = await Firebase.initializeApp();
      result = FireResult(success: true, message: "Firebase initialized successfully", data: fire);
      logNUI("NUIFirebase", "Initialization successful");
      for(NUIFireBuilder builder in _builders){
        builder.build(fire);
      }
    } catch (e){
      result = FireResult(success: false, message: e.toString());
    }

    return result;
  }
}

class NUIFireComponent{
  String name(){}
}

class NUIFireBuilder<T extends NUIFireComponent>{
  T build(FirebaseApp app){}
}
